var exp;			// current expression, lower case
var pos;			// current position
var len;			// expression length
var err;			// error status (blank for no error)
var base = 10;

// Token of various lengths
var tok1;
var tok2;
var tok3;
var tok4;
var tok5;


/**
 * Initialization: restore input field from cookie, set focus, and run evaluation.
 */
function calculator_onload()
{
	if(calculator_GetCookie("calculator_exp"))
	{
		document.forms["calculator_Form"].elements["edit[in]"].value = calculator_GetCookie("calculator_exp");
	}
	document.forms["calculator_Form"].elements["edit[in]"].focus();
	calculator_onchange(document.forms["calculator_Form"]);
	window.setInterval("calculator_onchange(document.forms[\"calculator_Form\"])", 1000);
}

function calculator_Error(info)
{
	if(err == "")
	{
		err = info+": "+exp.substr(0, pos)+"  "+exp.substring(pos, len);
	}
}

/**
* precedence (from low to high):
* 00 - no precedencd
* 10 - Addition
* 20 - Multiplikation
* 30 - Power
* 40 - Functions
* 50 - Factorial
*/


/**
 * evaluates some portion of the expression
 */
function calculator_Evaluate(prio, skippos)
{
	var result;

	pos += skippos;

	// Phase 1: skip blanks
	while(pos<len && exp.charAt(pos)==" ")
	{
		++pos;
	}
	tok1 = exp.substr(pos, 1);
	tok2 = exp.substr(pos, 2);
	tok3 = exp.substr(pos, 3);
	tok4 = exp.substr(pos, 4);
	tok5 = exp.substr(pos, 5);

	// Phase 2: find the first operand
	if("0123456789.,".indexOf(tok1) >= 0)					// literals
	{
		var mybase;
		if(tok2 == "0b")
			mybase = 2;
		else if(tok2 == "0o")
			mybase = 8;
		else if(tok2 == "0x")
			mybase = 16;
		else
			mybase = 10;
		if(mybase != 10)
			pos += 2;
		end = pos;
		var digits = "0123456789abcdef".substring(0, mybase);
		while(end<len && digits.indexOf(exp.charAt(end))>=0)
			++end;
		if(end == pos)
			result = 0;
		else
		{
			intpart = exp.substring(pos, end);
			result = 0;
			var idx;
			for(idx=0; idx<intpart.length; ++idx)
			{
				var digit = intpart.charAt(idx);
				result = result*mybase+digits.indexOf(digit);
			}
		}
		pos = end;
		if(end < len)
		{
			tok1 = exp.charAt(end);
			if(tok1=="." || tok1==",")
			{
				++pos;
				end = pos;
				while(end<len && digits.indexOf(exp.charAt(end))>=0)
					++end;
				var frcpart = exp.substring(pos, end);
				var idx;
				var result_frc = 0;
				for(idx=frcpart.length-1; idx>=0; --idx)
				{
					result_frc += digits.indexOf(frcpart.charAt(idx));
					result_frc /= mybase;
				}
				result += result_frc;
				pos = end;
			}
		}
	}
	else if(tok1 == "+")	result = calculator_Evaluate(10, 1);
	else if(tok1 == "-")	result = -calculator_Evaluate(10, 1);
	else if(tok3 == "abs") result = Math.abs(calculator_Evaluate(40, 3));
	else if(tok3 == "exp") result = Math.exp(calculator_Evaluate(40, 3));
	else if(tok3 == "log") result = Math.log(calculator_Evaluate(40, 3));
	else if(tok3 == "sin") result = Math.sin(calculator_Evaluate(40, 3));
	else if(tok3 == "cos") result = Math.cos(calculator_Evaluate(40, 3));
	else if(tok3 == "tan") result = Math.tan(calculator_Evaluate(40, 3));
	else if(tok4 == "asin") result = Math.asin(calculator_Evaluate(40, 4));
	else if(tok4 == "acos") result = Math.acos(calculator_Evaluate(40, 4));
	else if(tok4 == "atan") result = Math.atan(calculator_Evaluate(40, 4));
	else if(tok4 == "sqrt") result = Math.sqrt(calculator_Evaluate(40, 4));
	else if(tok5 == "round") result = Math.round(calculator_Evaluate(40,5));
	else if(tok5 == "floor") result = Math.floor(calculator_Evaluate(40,5));
	else if(tok4 == "ceil") result = Math.ceil(calculator_Evaluate(40, 4));
	else if(tok1 == "(")												  // Brackets
	{
		result = calculator_Evaluate(0, 1);
		if(tok1 != ")")
			calculator_Error(calculator_i18n_ClosingBracketExpected);
		else
			++pos;
	}
	else								                          // Constants
	{
		var found = -1;
		var idx;
		if(tok2 == "pi")									  		    // Pi
		{
			result = Math.PI;
			pos += 2;
		}
		else if(tok1 == "e")												// e
		{
			result = Math.E;
			pos++;
		}
		else																	      // no known operand -> error message
		{
			result = 0/0;
			calculator_Error(calculator_i18n_OperandExpected);
		}
	}

	// Phase 3: extend the term
	var go_on;
	do
	{
		go_on = true;
		while(pos<len && exp.charAt(pos)==" ")
			++pos;
		tok1 = exp.substr(pos, 1);
		tok2 = exp.substr(pos, 2);
		tok3 = exp.substr(pos, 3);
		tok4 = exp.substr(pos, 4);
		tok5 = exp.substr(pos, 5);
		if(prio<10 && tok1=="+")		result += calculator_Evaluate(10, 1);
		else if(prio<10 && tok1=="-") result -= calculator_Evaluate(10, 1);
		else if(prio<30 && tok2=="**") result = Math.pow(result, calculator_Evaluate(29, 2));
		else if(prio<20 && tok1=="*") result *= calculator_Evaluate(20, 1);
		else if(prio<20 && tok1=="/") result /= calculator_Evaluate(20, 1);
		else if(prio<20 && tok1=="%") result %= calculator_Evaluate(20, 1);
		else if(prio<30 && tok1=="^") result = Math.pow(result, calculator_Evaluate(29, 1));
		else if(prio<50 && tok1=="!")
		{
			n = Math.floor(result);
			result = n;
			while(n > 2)
				result *= --n;
			++pos;
		}
		else go_on = false;
	} while(go_on);

	return result;
}


/**
 * Evaluates the current expression
 */
function calculator_AnyEvaluate(evexp)
{
	var mypos = pos;
	var myexp = exp;
	var myerr = err;
	var mylen = len;

	pos = 0;
	err = "";
	exp = evexp.toLowerCase();
	len = exp.length;
	result_val = calculator_Evaluate(0, 0);
	if(pos < len)
		calculator_Error(calculator_i18n_EndOfExpressionExpected);
	result_err = err;

	pos = mypos;
	exp = myexp;
	err = myerr;
	len = mylen;
}


/*
* Evaluate the expression, if it changed
*/
function calculator_onchange(form)
{
	var exp = form.elements["edit[in]"].value.toLowerCase();
	var old = form.elements["edit[old]"].value.toLowerCase();
	base = parseInt(form.elements["edit[base]"].value);
	if(isNaN(base))
	{
		base = 10;
	}

	if(""+base+":"+exp!=old)
	{
		// Keep changes in mind
		old = ""+base+":"+exp;
		form.elements["edit[old]"].value = old;
		calculator_SetCookie("calculator_exp", exp, false, "/")

		// Evaluate the expression
		calculator_AnyEvaluate(exp, "");
		form.elements["edit[out]"].value = (result_err==""? calculator_BuildResult(result_val): result_err);
	}
	return true;
}


/**
 * Builds the result string: Numbers (base dependent), NaN, +-Inf
 */
function calculator_BuildResult(value)
{
	if(isNaN(value))
	{
		value = calculator_i18n_NotANumber;
	}
	else if(!isFinite(value))
	{
		value = value.toString().replace(/Infinity/, calculator_i18n_Infinity);
	}
	else if(base == 10)
	{
		value = value.toString().replace(/\./, calculator_i18n_DecimalPoint);
	}
	else
	{
		var result_bas;
		var result_sig = "";
		var result_pre = "";
		var result_frc = "";
		switch(base)
		{
			case 2:	result_bas = "0b"; break;
			case 8: result_bas = "0o"; break;
			case 16: result_bas = "0x"; break;
			default: result_bas = ""+base+":"; break;
		}
		if(value < 0)
		{
			result_sig = "-";
			value = -value;
		}
		var intpart = Math.floor(value);
		var frcpart = value-intpart;
		var digits = "0123456789abcdef";
		do {
			var digit = intpart % base;
			intpart = (intpart-digit) / base;
			result_pre = digits.charAt(digit)+result_pre;
		} while(intpart > 0);
		if(frcpart > 0)
			result_frc = calculator_i18n_DecimalPoint;
		while(frcpart>0 && result_frc.length<10)
		{
			frcpart *= base;
			var digit = Math.floor(frcpart);
			frcpart -= digit;
			result_frc = result_frc+digits.charAt(digit);
		}
		value = result_sig+result_bas+result_pre+result_frc;
	}
	return value;
}


/**
 * Cookie handling - taken from http://javarea.de
 */
function calculator_getCookieVal (offset) {
  var endstr = document.cookie.indexOf (";", offset);
  if (endstr == -1)
    endstr = document.cookie.length;
  return unescape(document.cookie.substring(offset, endstr));
}
function calculator_FixCookieDate (date) {
  var base = new Date(0);
  var skew = base.getTime(); // dawn of (Unix) time - should be 0
  if (skew > 0)  // Except on the Mac - ahead of its time
    date.setTime (date.getTime() - skew);
}
function calculator_GetCookie (name) {
  var arg = name + "=";
  var alen = arg.length;
  var clen = document.cookie.length;
  var i = 0;
  while (i < clen) {
    var j = i + alen;
    if (document.cookie.substring(i, j) == arg)
      return calculator_getCookieVal (j);
    i = document.cookie.indexOf(" ", i) + 1;
    if (i == 0) break;
  }
  return null;
}
function calculator_SetCookie (name,value,expires,path,domain,secure) {
  document.cookie = name + "=" + escape (value) +
    ((expires) ? "; expires=" + expires.toGMTString() : "") +
    ((path) ? "; path=" + path : "") +
    ((domain) ? "; domain=" + domain : "") +
    ((secure) ? "; secure" : "");
}
function calculator_DeleteCookie (name,path,domain) {
  if (calculator_GetCookie(name)) {
    document.cookie = name + "=" +
      ((path) ? "; path=" + path : "") +
      ((domain) ? "; domain=" + domain : "") +
      "; expires=Thu, 01-Jan-70 00:00:01 GMT";
  }
}